//THIS IS THE MAIN FILE FOR THE USB TYPEWRITER SOFTWARE
//IT IMPLEMENTS THE SETUP AND MAIN ROUTINES AND CALLS OUT NEEDED LIBRARIES

#define clearbit(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define setbit(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))

#include <UsbKeyboard.h>
#include <EEPROM.h>
#include "variables.h"
#include <avr/interrupt.h>
volatile static unsigned int mycounter = 0;

//Setup initializes ports, variables, and so on, then delays 3s.  It also checks if this is teach mode or not.
void setup() {
  delayMs(1); //Delay 1 millisecond
  configPorts();
  digitalWrite(13,HIGH);
  initializeTypewriter(); // Call initialize function.
  initializeUSB();
  SetupTimer2(); // set up timer2 to run every 20 ms (50Hz). timerLoadValue is the value loaded into timer2
  mycounter = 0;
//  TEACH_MODE = true;//debug only!!!
  while (mycounter<200){} //wait for 200*16ms = 3s
}

//Loop is controls whether we are in the Teach, Recall, or Listen thread.
void loop() {
  if(TEACH_MODE){

    teach();
  }
  else if(RECALL_MODE){
    recall();
  }
  else{
 // USBSend(KEY_L);
    listen();
  }
}



